# Copyright (c) 2014 Chen Zhaoqiang DDDC SIMM
#qq 744891290 qqgroup 144539789
# A PyMOL script for drawing a CGO box by the coordinate of the center,and the size of box
#center_x,center_y,center_z,size_x,size_y,size_z,



import pymol
from pymol import cmd
from pymol.wizard import Wizard
from chempy import cpv
from pymol.cgo import *
from pymol import cmd
from pymol.cgo import *
from pymol.vfont import plain


def loadxyzrgb(filen):
    fh = open(filen) 
    name = filen.split('.')[0]
    colordict={}
    obj01=[]
    obj01=[BEGIN, POINTS, COLOR, 1.0, 0.1, 1.0 ]
    for line in fh.readlines():
        elems = line.strip().split()
        if len(elems)>=6:
            x,y,z,r,g,b=elems[0:6]
            obj01.extend([SPHERE,float(x),float(y),float(z),1.0])
            k="%s_%s_%s"%(r,g,b)
            if k not in colordict:
                colordict[k] = [[x,y,z]]
            else:
                colordict[k].append([x,y,z])
    obj01.append(END)

    objs=[]

    objname="id%s"
    i=0
    for k in colordict:
        i+=1
        objname="objname%02d"%i

        cr, cg, cb= list(map(float,k.split('_')[0:3]))

        obj=[ COLOR, cr, cg, cb ]
        for xyz in colordict[k]:
            x,y,z=map(float,xyz)
            obj.extend([SPHERE,x,y,z,1.0])
        objs.extend(obj)
    cmd.load_cgo(objs, name)


cmd.extend('loadxyzrgb', loadxyzrgb)

